#include <vd2/plugin/vdvideofilt.h>
#include <vector>

extern VDXFilterDefinition filterDef_verticalBlur;
extern VDXFilterDefinition filterDef_yuvTransform;

static VDXFilterDefinition *g_filterDefs[]={
	&filterDef_verticalBlur,
	&filterDef_yuvTransform,
};

VDXFilterDefinition *g_registeredFilters[sizeof(g_filterDefs)/sizeof(g_filterDefs[0])];

int g_VFVAPIVersion;

extern "C" __declspec(dllexport) int __cdecl VirtualdubFilterModuleInit2(struct VDXFilterModule *fm, const VDXFilterFunctions *ff, int& vdfd_ver, int& vdfd_compat) {
	for(int i=0; i<sizeof(g_filterDefs)/sizeof(g_filterDefs[0]); ++i)
	    g_registeredFilters[i] = ff->addFilter(fm, g_filterDefs[i], sizeof(VDXFilterDefinition));

	g_VFVAPIVersion = vdfd_ver;
    vdfd_ver        = VIRTUALDUB_FILTERDEF_VERSION;
	vdfd_compat     = VIRTUALDUB_FILTERDEF_COMPATIBLE_COPYCTOR;

    return 0;
}

extern "C" __declspec(dllexport) void __cdecl VirtualdubFilterModuleDeinit(struct VDXFilterModule *fm, const VDXFilterFunctions *ff) {
	for(int i=sizeof(g_filterDefs)/sizeof(g_filterDefs[0])-1; i>=0; --i) {
		VDXFilterDefinition *def = g_registeredFilters[i];

	    if (def)
			ff->removeFilter(def);
	}
}
